<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/timer_manager_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>06/20/87  timer_manager_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The timer_manager_ subroutine allows many CPU usage timers and
<span id="L4" class="LineNr">  4 </span>real-time timers to be used simultaneously by a process.  The caller
<span id="L5" class="LineNr">  5 </span>can specify for each timer whether a wakeup is to be issued or a
<span id="L6" class="LineNr">  6 </span>specified procedure is to be called when the timer goes off.  If a
<span id="L7" class="LineNr">  7 </span>procedure is to be called, the calling procedure can specify a data
<span id="L8" class="LineNr">  8 </span>pointer to pass to that procedure.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Detailed information can be found in Multics Subroutines and I/O
<span id="L11" class="LineNr"> 11 </span>Modules <span class="textRainbow_lv0_p0">(</span>AG93<span class="textRainbow_lv0_p0">)</span>.
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Entry points in timer_manager_:
<span id="L15" class="LineNr"> 15 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>:Entry: alarm_call:  06/20/87 timer_manager_$alarm_call
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Function:  This entry point sets up a real-time timer that calls the
<span id="L22" class="LineNr"> 22 </span>routine specified when the timer goes off.
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Syntax:
<span id="L26" class="LineNr"> 26 </span>dcl timer_manager_$alarm_call entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> entry<span class="textRainbow_lv0_o0">,</span>
<span id="L27" class="LineNr"> 27 </span>     ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L28" class="LineNr"> 28 </span>call timer_manager_$alarm_call <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> routine<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span>
<span id="L31" class="LineNr"> 31 </span>Arguments:
<span id="L32" class="LineNr"> 32 </span>time
<span id="L33" class="LineNr"> 33 </span>   is the time at which the wakeup or call is desired.
<span id="L34" class="LineNr"> 34 </span>flags
<span id="L35" class="LineNr"> 35 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L36" class="LineNr"> 36 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L37" class="LineNr"> 37 </span>   constants:
<span id="L38" class="LineNr"> 38 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L39" class="LineNr"> 39 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr"> 40 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr"> 41 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L42" class="LineNr"> 42 </span>routine
<span id="L43" class="LineNr"> 43 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>data_ptr
<span id="L47" class="LineNr"> 47 </span>   is a pointer to a data structure which is to be associated with this
<span id="L48" class="LineNr"> 48 </span>   particular timer.
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>:Entry:  alarm_call_inhibit:  06/20/87 timer_manager_$alarm_call_inhibit
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>Function:  This entry point sets up a real-time timer that calls the
<span id="L55" class="LineNr"> 55 </span>handler routine specified when the timer goes off.  The call is made
<span id="L56" class="LineNr"> 56 </span>with all interrupts inhibited <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> all interprocess signal <span class="textRainbow_lv1_p0">(</span>IPS<span class="textRainbow_lv1_p0">)</span> are
<span id="L57" class="LineNr"> 57 </span>masked off<span class="textRainbow_lv0_p0">)</span>.  When the handler routine returns, interrupts are
<span id="L58" class="LineNr"> 58 </span>reenabled.  If the handler routine does not return, interrupts are not
<span id="L59" class="LineNr"> 59 </span>reenabled and the user process may malfunction.
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>Syntax:
<span id="L63" class="LineNr"> 63 </span>dcl timer_manager_$alarm_call_inhibit entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L64" class="LineNr"> 64 </span>     entry<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L65" class="LineNr"> 65 </span>call timer_manager_$alarm_call_inhibit <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> routine<span class="textRainbow_lv0_o0">,</span>
<span id="L66" class="LineNr"> 66 </span>     data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>Arguments:
<span id="L70" class="LineNr"> 70 </span>time
<span id="L71" class="LineNr"> 71 </span>   is the time at which the wakeup or call is desired.
<span id="L72" class="LineNr"> 72 </span>flags
<span id="L73" class="LineNr"> 73 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L74" class="LineNr"> 74 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L75" class="LineNr"> 75 </span>   constants:
<span id="L76" class="LineNr"> 76 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L77" class="LineNr"> 77 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L78" class="LineNr"> 78 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L80" class="LineNr"> 80 </span>routine
<span id="L81" class="LineNr"> 81 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>data_ptr
<span id="L85" class="LineNr"> 85 </span>   is a pointer to a data structure which is to be associated with this
<span id="L86" class="LineNr"> 86 </span>   particular timer.
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>:Entry:  alarm_wakeup:  06/20/87 timer_manager_$alarm_wakeup
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>Function:  This entry point sets up a real-time timer that issues a
<span id="L93" class="LineNr"> 93 </span>wakeup on the event channel specified when the timer goes off.  The
<span id="L94" class="LineNr"> 94 </span>event message passed is the string &quot;alarm___&quot;.  <span class="textRainbow_lv0_p0">(</span>See the ipc_
<span id="L95" class="LineNr"> 95 </span>subroutine for a discussion of event channels.<span class="textRainbow_lv0_p0">)</span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>Syntax:
<span id="L99" class="LineNr"> 99 </span>declare timer_manager_$alarm_wakeup entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L100" class="LineNr">100 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L101" class="LineNr">101 </span>call timer_manager_$alarm_wakeup <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> channel<span class="textRainbow_lv0_p0">)</span>;
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>Arguments:
<span id="L105" class="LineNr">105 </span>time
<span id="L106" class="LineNr">106 </span>   is the time at which the wakeup or call is desired.
<span id="L107" class="LineNr">107 </span>flags
<span id="L108" class="LineNr">108 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L109" class="LineNr">109 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L110" class="LineNr">110 </span>   constants:
<span id="L111" class="LineNr">111 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L112" class="LineNr">112 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L113" class="LineNr">113 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L114" class="LineNr">114 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>channel
<span id="L118" class="LineNr">118 </span>   is the name of the event channel over which a
<span id="L119" class="LineNr">119 </span>   wakeup is desired.  Two or more timers can be running
<span id="L120" class="LineNr">120 </span>   simultaneously, all of which may, if desired, issue a wakeup on the
<span id="L121" class="LineNr">121 </span>   same event channel.
<span id="L122" class="LineNr">122 </span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>:Entry:  cpu_call:  06/20/87 timer_manager_$cpu_call
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>Function:  This entry point sets up a CPU timer that calls the routine
<span id="L128" class="LineNr">128 </span>specified when the timer goes off.
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>Syntax:
<span id="L132" class="LineNr">132 </span>dcl timer_manager_$cpu_call entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> entry<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L133" class="LineNr">133 </span>call timer_manager_$cpu_call <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> routine<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>Arguments:
<span id="L137" class="LineNr">137 </span>time
<span id="L138" class="LineNr">138 </span>   is the time at which the wakeup or call is desired.
<span id="L139" class="LineNr">139 </span>flags
<span id="L140" class="LineNr">140 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L141" class="LineNr">141 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L142" class="LineNr">142 </span>   constants:
<span id="L143" class="LineNr">143 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L144" class="LineNr">144 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L145" class="LineNr">145 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L146" class="LineNr">146 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L147" class="LineNr">147 </span>routine
<span id="L148" class="LineNr">148 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>
<span id="L151" class="LineNr">151 </span>data_ptr
<span id="L152" class="LineNr">152 </span>   is a pointer to a data structure which is to be associated with this
<span id="L153" class="LineNr">153 </span>   particular timer.
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>:Entry:  cpu_call_inhibit:  06/20/87 timer_manager_$cpu_call_inhibit
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>
<span id="L159" class="LineNr">159 </span>Function:  This entry point sets up a CPU timer that calls the handler
<span id="L160" class="LineNr">160 </span>routine specified when the timer goes off.  The call is made with all
<span id="L161" class="LineNr">161 </span>interrupts inhibited <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> all IPS are masked off<span class="textRainbow_lv0_p0">)</span>.  When the handler
<span id="L162" class="LineNr">162 </span>routine returns, interrupts are reenabled.  If the handler routine does
<span id="L163" class="LineNr">163 </span>not return, interrupts are not reenabled and the user process may
<span id="L164" class="LineNr">164 </span>malfunction.
<span id="L165" class="LineNr">165 </span>
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>Syntax:
<span id="L168" class="LineNr">168 </span>dcl timer_manager_$cpu_call_inhibit entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L169" class="LineNr">169 </span>     entry<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L170" class="LineNr">170 </span>call timer_manager_$cpu_call_inhibit <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> routine<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>Arguments:
<span id="L174" class="LineNr">174 </span>time
<span id="L175" class="LineNr">175 </span>   is the time at which the wakeup or call is desired.
<span id="L176" class="LineNr">176 </span>flags
<span id="L177" class="LineNr">177 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L178" class="LineNr">178 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L179" class="LineNr">179 </span>   constants:
<span id="L180" class="LineNr">180 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L181" class="LineNr">181 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L182" class="LineNr">182 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L183" class="LineNr">183 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L184" class="LineNr">184 </span>routine
<span id="L185" class="LineNr">185 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L186" class="LineNr">186 </span>
<span id="L187" class="LineNr">187 </span>
<span id="L188" class="LineNr">188 </span>data_ptr
<span id="L189" class="LineNr">189 </span>   is a pointer to a data structure which is to be associated with this
<span id="L190" class="LineNr">190 </span>   particular timer.
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>:Entry:  cpu_wakeup:  04/12/87 timer_manager_$cpu_wakeup
<span id="L194" class="LineNr">194 </span>
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>Function:  This entry point sets up a CPU timer that issues a wakeup on
<span id="L197" class="LineNr">197 </span>the event channel specified when the timer goes off.  The event message
<span id="L198" class="LineNr">198 </span>passed is the string &quot;cpu_time&quot;.
<span id="L199" class="LineNr">199 </span>
<span id="L200" class="LineNr">200 </span>
<span id="L201" class="LineNr">201 </span>Syntax:
<span id="L202" class="LineNr">202 </span>declare timer_manager_$cpu_wakeup entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L203" class="LineNr">203 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L204" class="LineNr">204 </span>call timer_manager_$cpu_wakeup <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_o0">,</span> channel<span class="textRainbow_lv0_p0">)</span>;
<span id="L205" class="LineNr">205 </span>
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>Arguments:
<span id="L208" class="LineNr">208 </span>time
<span id="L209" class="LineNr">209 </span>   is the time at which the wakeup or call is desired.
<span id="L210" class="LineNr">210 </span>flags
<span id="L211" class="LineNr">211 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L212" class="LineNr">212 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L213" class="LineNr">213 </span>   constants:
<span id="L214" class="LineNr">214 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L215" class="LineNr">215 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L216" class="LineNr">216 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L217" class="LineNr">217 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L218" class="LineNr">218 </span>
<span id="L219" class="LineNr">219 </span>
<span id="L220" class="LineNr">220 </span>channel
<span id="L221" class="LineNr">221 </span>   is the name of the event channel over which a
<span id="L222" class="LineNr">222 </span>   wakeup is desired.  Two or more timers can be running
<span id="L223" class="LineNr">223 </span>   simultaneously, all of which may, if desired, issue a wakeup on the
<span id="L224" class="LineNr">224 </span>   same event channel.
<span id="L225" class="LineNr">225 </span>
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>:Entry:  reset_alarm_call:  04/12/87 timer_manager_$reset_alarm_call
<span id="L228" class="LineNr">228 </span>
<span id="L229" class="LineNr">229 </span>
<span id="L230" class="LineNr">230 </span>Function:  This entry point turns off all real-time timers that call
<span id="L231" class="LineNr">231 </span>the routine specified when they go off.
<span id="L232" class="LineNr">232 </span>
<span id="L233" class="LineNr">233 </span>
<span id="L234" class="LineNr">234 </span>Syntax:
<span id="L235" class="LineNr">235 </span>dcl timer_manager_$reset_alarm_call entry <span class="textRainbow_lv0_p0">(</span>entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L236" class="LineNr">236 </span>call timer_manager_$reset_alarm_call <span class="textRainbow_lv0_p0">(</span>routine<span class="textRainbow_lv0_p0">)</span>;
<span id="L237" class="LineNr">237 </span>   OR
<span id="L238" class="LineNr">238 </span>dcl timer_manager_$reset_alarm_call entry <span class="textRainbow_lv0_p0">(</span>entry<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L239" class="LineNr">239 </span>call timer_manager_$reset_alarm_call <span class="textRainbow_lv0_p0">(</span>routine<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L240" class="LineNr">240 </span>
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>Arguments:
<span id="L243" class="LineNr">243 </span>routine
<span id="L244" class="LineNr">244 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L245" class="LineNr">245 </span>data_ptr
<span id="L246" class="LineNr">246 </span>   is a pointer to a data structure which is to be associated with this
<span id="L247" class="LineNr">247 </span>   particular timer.
<span id="L248" class="LineNr">248 </span>
<span id="L249" class="LineNr">249 </span>
<span id="L250" class="LineNr">250 </span>Notes: If the data_ptr is provided, all real-time timers which are to
<span id="L251" class="LineNr">251 </span>call the given routine with that value of data_ptr are cancelled.
<span id="L252" class="LineNr">252 </span>Otherwise, all real-time timers which are to call that routine with
<span id="L253" class="LineNr">253 </span>any value of data_ptr are cancelled.
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>:Entry:  reset_alarm_wakeup:  04/12/87 timer_manager_$reset_alarm_wakeup
<span id="L257" class="LineNr">257 </span>
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>Function:  This entry point turns off all real-time timers that issue a
<span id="L260" class="LineNr">260 </span>wakeup on the event channel specified when they go off.
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>
<span id="L263" class="LineNr">263 </span>Syntax:
<span id="L264" class="LineNr">264 </span>declare timer_manager_$reset_alarm_wakeup entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L265" class="LineNr">265 </span>call timer_manager_$reset_alarm_wakeup <span class="textRainbow_lv0_p0">(</span>channel<span class="textRainbow_lv0_p0">)</span>;
<span id="L266" class="LineNr">266 </span>
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>Arguments:
<span id="L269" class="LineNr">269 </span>channel
<span id="L270" class="LineNr">270 </span>   is the name of the event channel over which a
<span id="L271" class="LineNr">271 </span>   wakeup is desired.  Two or more timers can be running
<span id="L272" class="LineNr">272 </span>   simultaneously, all of which may, if desired, issue a wakeup on the
<span id="L273" class="LineNr">273 </span>   same event channel.
<span id="L274" class="LineNr">274 </span>
<span id="L275" class="LineNr">275 </span>
<span id="L276" class="LineNr">276 </span>:Entry:  reset_cpu_call:  04/12/87 timer_manager_$reset_cpu_call
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>Function:  This entry point turns off all CPU timers that call the
<span id="L280" class="LineNr">280 </span>routine specified when they go off.
<span id="L281" class="LineNr">281 </span>
<span id="L282" class="LineNr">282 </span>
<span id="L283" class="LineNr">283 </span>Syntax:
<span id="L284" class="LineNr">284 </span>declare timer_manager_$reset_cpu_call entry <span class="textRainbow_lv0_p0">(</span>entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L285" class="LineNr">285 </span>call timer_manager_$reset_cpu_call <span class="textRainbow_lv0_p0">(</span>routine<span class="textRainbow_lv0_p0">)</span>;
<span id="L286" class="LineNr">286 </span>   OR
<span id="L287" class="LineNr">287 </span>declare timer_manager_$reset_cpu_call entry <span class="textRainbow_lv0_p0">(</span>entry<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L288" class="LineNr">288 </span>call timer_manager_$reset_cpu_call <span class="textRainbow_lv0_p0">(</span>routine<span class="textRainbow_lv0_o0">,</span> data_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L289" class="LineNr">289 </span>
<span id="L290" class="LineNr">290 </span>
<span id="L291" class="LineNr">291 </span>Arguments:
<span id="L292" class="LineNr">292 </span>routine
<span id="L293" class="LineNr">293 </span>   is a procedure entry point that is called when the timer goes off.
<span id="L294" class="LineNr">294 </span>data_ptr
<span id="L295" class="LineNr">295 </span>   is a pointer to a data structure which is to be associated with this
<span id="L296" class="LineNr">296 </span>   particular timer.
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>
<span id="L299" class="LineNr">299 </span>Notes: If the data_ptr is provided, all CPU timers which are to call
<span id="L300" class="LineNr">300 </span>the given routine with that value of data_ptr are cancelled.
<span id="L301" class="LineNr">301 </span>Otherwise, all CPU timers which are to call the routine with any value
<span id="L302" class="LineNr">302 </span>of data_ptr are cancelled.
<span id="L303" class="LineNr">303 </span>
<span id="L304" class="LineNr">304 </span>
<span id="L305" class="LineNr">305 </span>:Entry:  reset_cpu_wakeup:  04/12/87 timer_manager_$reset_cpu_wakeup
<span id="L306" class="LineNr">306 </span>
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>Function:  This entry point turns off all CPU timers that issue a
<span id="L309" class="LineNr">309 </span>wakeup on the event channel specified when they go off.
<span id="L310" class="LineNr">310 </span>
<span id="L311" class="LineNr">311 </span>
<span id="L312" class="LineNr">312 </span>Syntax:
<span id="L313" class="LineNr">313 </span>declare timer_manager_$reset_cpu_wakeup entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L314" class="LineNr">314 </span>call timer_manager_$reset_cpu_wakeup <span class="textRainbow_lv0_p0">(</span>channel<span class="textRainbow_lv0_p0">)</span>;
<span id="L315" class="LineNr">315 </span>
<span id="L316" class="LineNr">316 </span>
<span id="L317" class="LineNr">317 </span>Arguments:
<span id="L318" class="LineNr">318 </span>channel
<span id="L319" class="LineNr">319 </span>   is the name of the event channel over which a
<span id="L320" class="LineNr">320 </span>   wakeup is desired.  Two or more timers can be running
<span id="L321" class="LineNr">321 </span>   simultaneously, all of which may, if desired, issue a wakeup on the
<span id="L322" class="LineNr">322 </span>   same event channel.
<span id="L323" class="LineNr">323 </span>
<span id="L324" class="LineNr">324 </span>
<span id="L325" class="LineNr">325 </span>:Entry:  sleep:  04/12/87 timer_manager_$sleep
<span id="L326" class="LineNr">326 </span>
<span id="L327" class="LineNr">327 </span>
<span id="L328" class="LineNr">328 </span>Function:  This entry point causes the process to go blocked for a
<span id="L329" class="LineNr">329 </span>period of real time.  Other timers that are active continue to be
<span id="L330" class="LineNr">330 </span>processed whenever they go off; however, this routine does not return
<span id="L331" class="LineNr">331 </span>until the real time has been passed.
<span id="L332" class="LineNr">332 </span>
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>Syntax:
<span id="L335" class="LineNr">335 </span>dcl timer_manager_$sleep entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L336" class="LineNr">336 </span>call timer_manager_$sleep <span class="textRainbow_lv0_p0">(</span>time<span class="textRainbow_lv0_o0">,</span> flags<span class="textRainbow_lv0_p0">)</span>;
<span id="L337" class="LineNr">337 </span>
<span id="L338" class="LineNr">338 </span>
<span id="L339" class="LineNr">339 </span>Arguments:
<span id="L340" class="LineNr">340 </span>time
<span id="L341" class="LineNr">341 </span>   is the time at which the wakeup or call is desired.
<span id="L342" class="LineNr">342 </span>flags
<span id="L343" class="LineNr">343 </span>   is a 2-bit string that determines how time is to be interpreted.
<span id="L344" class="LineNr">344 </span>   timer_manager_constants.incl.pl1 defines the following named
<span id="L345" class="LineNr">345 </span>   constants:
<span id="L346" class="LineNr">346 </span>    ABSOLUTE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;00&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L347" class="LineNr">347 </span>    ABSOLUTE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;01&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L348" class="LineNr">348 </span>    RELATIVE_MICROSECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;10&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L349" class="LineNr">349 </span>    RELATIVE_SECONDS <span class="textRainbow_lv0_p0">(</span>=&quot;11&quot;b<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
